/*
 * Programming in Java, Jacobs University, 2015
 *
 * This file implements ServeEchoClient, a Runnable that serves a
 * single echo client.
 */

import java.net.Socket;
import java.io.Reader;
import java.io.Writer;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.OutputStreamWriter;
import java.io.BufferedWriter;
import java.io.PrintWriter;

public class ServeEchoClient
    implements Runnable
{
    private Socket socket;
    private BufferedReader in;
    private PrintWriter out;

    public ServeEchoClient(Socket s)
	throws IOException
    {
	socket = s;

	in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
	out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
    }
    
    public void run()
    {
	try {
	    while (true) {
		String str = in.readLine();
		if (str == null) break;
		out.println(str);
	    }
	} catch (IOException e) {
	    System.err.println(e);
	} finally {
	    try {
		socket.close();
	    } catch (IOException e) {
		System.err.println(e);
	    }
	}
    }
}
